<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { ref, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'
import MapView from '@/views/Branch/MapView.vue'
import { useUserStore } from '@/stores/user';

const visible = ref(false)
const email = ref('prapphisin@email.com')
const password = ref('Pass@1234')

const authStore = useAuthStore()

const refForm = ref<VForm | null>(null)
const form = ref(false)

const required = (v: string) => {
  return !!v || 'Field is required'
}

const onSubmit = async () => {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  authStore.login(email.value, password.value)
}
onMounted(() => {
  useUserStore().editedUser = useAuthStore().getCurrentUser()
})
</script>

<template>
  <div>
    <v-sheet style="background-color: antiquewhite;">
      <v-container fluid>
        <v-row>
          <v-col cols="12" sm="12">
            <v-card class="mx-auto pa-12 pb-8" elevation="8" max-width="450">
              <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-img
                  style="display: block; margin: auto"
                  alt="Logo"
                  width="250px"
                  src="./img/logo/logo_brown_text.png"
                ></v-img>
                <div class="text-subtitle-1 text-medium-emphasis">Account</div>

                <v-text-field
                  v-model="email"
                  :rules="[required]"
                  clearable
                  density="compact"
                  placeholder="Email address"
                  prepend-inner-icon="mdi-email-outline"
                  variant="outlined"
                ></v-text-field>

                <div
                  class="text-subtitle-1 text-medium-emphasis d-flex align-center justify-space-between"
                >
                  Password
                </div>

                <v-text-field
                  v-model="password"
                  :rules="[required]"
                  clearable
                  :append-inner-icon="visible ? 'mdi-eye-off' : 'mdi-eye'"
                  :type="visible ? 'text' : 'password'"
                  density="compact"
                  placeholder="Enter your password"
                  prepend-inner-icon="mdi-lock-outline"
                  variant="outlined"
                  @click:append-inner="visible = !visible"
                ></v-text-field>

                <br />

                <v-btn
                  :disabled="!form"
                  block
                  class="mb-8"
                  size="large"
                  type="submit"
                  variant="elevated"
                >
                  Log In
                </v-btn>
              </v-form>
              <v-dialog v-model="authStore.mapDialog" max-width="400" height="700">
                <v-card class="px-2">
                  <v-card-title class="text-h5 d-flex justify-center"
                    >กำลังตั้งค่าพิกัด</v-card-title
                  >
                  <v-row class="d-flex justify-center align-center">
                    <map-view></map-view>
                  </v-row>
                </v-card>
              </v-dialog>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </v-sheet>
  </div>
</template>

<style scoped>
.v-sheet {
  background-image: url('./img/logo/BG1.png');
  background-size: cover;
  background-position: center;
  height: 93vh;
  display: flex;
  justify-content: center;
  align-items: center;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 30px;
  padding: 8px 16px;
}

.v-card {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}
</style>
